diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index b911eb426..7d97f88e5 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -1,13 +1,12 @@
 package net.minecraft.core.entity.animal;
 
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
-import net.minecraft.core.item.ItemFood;
-import net.minecraft.core.item.IArmorItem;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
-import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.enums.WolfArmorShape;
+import net.minecraft.core.item.*;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.util.helper.MathHelper;
@@ -23,18 +22,18 @@ import java.util.*;
 
 public class MobWolf
     extends MobAnimal
-    implements IItemHolding// ,
+    implements IItemHolding, IArmorWearing<WolfArmorShape>
 //    AgedMob
 {
     public static final Map<ArmorMaterial, IArmorItem<?>> ARMOR_MATERIALS = new HashMap<>();
 
     static {
-        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_LEATHER);
-        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_CHAINMAIL);
-        ARMOR_MATERIALS.put(ArmorMaterial.IRON, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_IRON);
-        ARMOR_MATERIALS.put(ArmorMaterial.GOLD, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_GOLD);
-        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_DIAMOND);
-        ARMOR_MATERIALS.put(ArmorMaterial.STEEL, (IArmorItem<?>) Items.ARMOR_CHESTPLATE_STEEL);
+        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER, (IArmorItem<?>) Items.ARMOR_WOLF_LEATHER);
+        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (IArmorItem<?>) Items.ARMOR_WOLF_CHAINMAIL);
+        ARMOR_MATERIALS.put(ArmorMaterial.IRON, (IArmorItem<?>) Items.ARMOR_WOLF_IRON);
+        ARMOR_MATERIALS.put(ArmorMaterial.GOLD, (IArmorItem<?>) Items.ARMOR_WOLF_GOLD);
+        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND, (IArmorItem<?>) Items.ARMOR_WOLF_DIAMOND);
+        ARMOR_MATERIALS.put(ArmorMaterial.STEEL, (IArmorItem<?>) Items.ARMOR_WOLF_STEEL);
     }
 
     public static final int DATA_HELD_ITEM = 15;
@@ -43,7 +42,7 @@ public class MobWolf
     public static final int MASK_ANGRY = 0b0000_0010;
     public static final int MASK_TAMED = 0b0000_0100;
     public static final int DATA_OWNER_UUID = 17;
-    public static final int DATA_ARMOR_MATERIAL = 19;
+    public static final int DATA_ARMOR_ITEM = 19;
 
     private boolean looksWithInterest;
     private float interestedAngle;
@@ -52,7 +51,6 @@ public class MobWolf
     private boolean field_25052_g;
     private float timeWolfIsShaking;
     private float prevTimeWolfIsShaking;
-    private ItemStack armor = null;
 //    private final @NotNull MobAge age;
 
     public MobWolf(World world) {
@@ -71,7 +69,7 @@ public class MobWolf
         this.entityData.define(DATA_HELD_ITEM, null, ItemStack.class);
         this.entityData.define(DATA_GENERIC_FLAGS, (byte) 0, Byte.class);
         this.entityData.define(DATA_OWNER_UUID, null, UUID.class);
-        this.entityData.define(DATA_ARMOR_MATERIAL, "", String.class);
+        this.entityData.define(DATA_ARMOR_ITEM, null, ItemStack.class);
     }
 
     @Override
@@ -91,31 +89,15 @@ public class MobWolf
         }
     }
 
-    public @Nullable ArmorMaterial getArmorMaterial() {
-        ArmorMaterial material = null;
-        final String name = this.entityData.getString(DATA_ARMOR_MATERIAL);
-        if (name == null) return null;
-        for (final ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
-            if (mat.identifier.toString().equalsIgnoreCase(name)) {
-                material = mat;
-                break;
-            }
-        }
-
-        return material;
+    public @Nullable ItemStack getArmorItem() {
+        final @Nullable ItemStack item = this.entityData.getItemStack(DATA_ARMOR_ITEM);
+        if (item == null || !(item.getItem() instanceof @NotNull IArmorItem<?>)) return null;
+        return item;
     }
 
-    public void setArmor(final ItemStack stack) {
-        ArmorMaterial material = null;
-        this.armor = stack;
-        if (stack != null && stack.getItem() instanceof IArmorItem && ARMOR_MATERIALS.containsValue(stack.getItem())) {
-            material = ((IArmorItem<?>) stack.getItem()).getArmorMaterial();
-        }
-        if (material == null) {
-            this.entityData.set(DATA_ARMOR_MATERIAL, null);
-        } else {
-            this.entityData.set(DATA_ARMOR_MATERIAL, material.identifier.toString());
-        }
+    public void setArmorItem(final @Nullable ItemStack stack) {
+        if (stack != null && (!(stack.getItem() instanceof IArmorItem<?> armorItem) || armorItem.getArmorShape() != WolfArmorShape.BODY)) return;
+        this.entityData.set(DATA_ARMOR_ITEM, stack);
     }
 
     @Override
@@ -166,9 +148,9 @@ public class MobWolf
 
             tag.putCompound("HeldItem", heldItemNBT);
         }
-        if (getArmorMaterial() != null) {
+        if (getArmorItem() != null) {
             CompoundTag armorTag = new CompoundTag();
-            this.armor.writeToNBT(armorTag);
+            getArmorItem().writeToNBT(armorTag);
             tag.putCompound("Armor", armorTag);
         }
         UUIDHelper.writeToTag(tag, getWolfOwner(), "OwnerUUID");
@@ -191,21 +173,26 @@ public class MobWolf
         }
 
         if (tag.containsKey("Armor")) {
-            ArmorMaterial material = null;
-            String name = tag.getString("Armor");
-            if (!name.isEmpty()) {
-                for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
-                    if (mat.identifier.toString().equalsIgnoreCase(name)) {
-                        material = mat;
-                        break;
+            Tag<?> armorTag = tag.getTag("Armor");
+
+            if (armorTag instanceof StringTag stringTag) {
+                ArmorMaterial material = null;
+                String name = stringTag.getValue();
+                if (!name.isEmpty()) {
+                    for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
+                        if (mat.identifier.toString().equalsIgnoreCase(name)) {
+                            material = mat;
+                            break;
+                        }
                     }
+                    Item item = ARMOR_MATERIALS.get(material).asItem();
+                    setArmorItem(item.getDefaultStack());
+                } else {
+                    setArmorItem(null);
                 }
-                Item item = ARMOR_MATERIALS.get(material).asItem();
-                setArmor(item.getDefaultStack());
-            } else {
-                CompoundTag armorTag = tag.getCompound("Armor");
-                ItemStack armor = ItemStack.readItemStackFromNbt(armorTag);
-                setArmor(armor);
+            } else if (armorTag instanceof CompoundTag compoundTag) {
+                final @Nullable ItemStack armorItem = ItemStack.readItemStackFromNbt(compoundTag);
+                this.setArmorItem(armorItem);
             }
 
         }
@@ -229,6 +216,11 @@ public class MobWolf
 //        this.age.readTag(tag);
     }
 
+    @Override
+    public boolean isSpawnCapExempt() {
+        return this.getWolfOwner() != null;
+    }
+
     @Override
     protected boolean canDespawn() {
         return !isWolfTamed() && super.canDespawn();
@@ -278,9 +270,9 @@ public class MobWolf
             dropItem(getHeldItem(), 0.0f);
             setHeldItem(null);
         }
-        if (this.armor != null && this.armor.stackSize > 0) {
-            dropItem(this.armor, 0);
-            setArmor(null);
+        if (this.getArmorItem() != null) {
+            dropItem(this.getArmorItem(), 0);
+            this.setArmorItem(null);
         }
         super.dropDeathItems();
     }
@@ -442,7 +434,7 @@ public class MobWolf
                 for (int j = 0; j < i; j++) {
                     double offX = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth * 0.5F;
                     double offZ = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth * 0.5F;
-                    this.world.spawnParticle("splash", this.x + offX, f + 0.8F, this.z + offZ, this.xd, this.yd, this.zd, 0);
+                    this.world.spawnParticle("splash", this.x + offX, f + 0.8F, this.z + offZ, this.xd, this.yd, this.zd, this.world.dimension.id);
                 }
 
             }
@@ -586,47 +578,46 @@ public class MobWolf
 
     @Override
     protected void damageEntity(int damage, DamageType damageType) {
-        if (getArmorMaterial() == null) {
-            super.damageEntity(damage, damageType);
-            return;
+        float protection = 1.0f;
+        if (damageType != null) {
+            protection -= getTotalProtectionAmount(damageType);
         }
-
-        float protection = 1.0f - getArmorMaterial().getProtection(damageType);
         protection = Math.max(protection, 0.01f);
 
         //If you take little damage and have lots of protection against that damage
-        //there is a high change you wont take any damage
+        //there is a high change you won't take any damage
         double d = damage * protection;
-        int newDamage = (int) (this.random.nextFloat() > 0.5 ? Math.floor(d) : Math.ceil(d));
+        int newDamage = (int) (random.nextFloat() > 0.5 ? Math.floor(d) : Math.ceil(d));
 
-        super.damageEntity(newDamage, damageType);
+        int preventedDamage = damage - newDamage;
+        if(damageType != null && damageType.shouldDamageArmor()){
+            //Reduce armor for big damage amounts, for example explosions
+            int armorDamage = (int) Math.ceil(preventedDamage / 4.0);
+            damageArmor(armorDamage);
+        }
+
+        super.damageEntity(damage, damageType);
     }
 
     public void lavaHurt() {
-        if (!this.fireImmune) {
-            float protection = 0;
-            ArmorMaterial material;
-            if ((material = getArmorMaterial()) != null) {
-                protection = 1.0f - material.getProtection(DamageType.FIRE);
-            }
+        if(!fireImmune)
+        {
+            float protection = 1.0f - getTotalProtectionAmount(DamageType.FIRE);
             protection = Math.max(protection, 0.01f);
             hurt(null, 4, DamageType.FIRE);
-            this.remainingFireTicks = (int) (80 + 520 * protection);
-            this.maxFireTicks = this.remainingFireTicks;
+            remainingFireTicks = (int) (80 + 520 * protection);
+            maxFireTicks = remainingFireTicks;
         }
     }
 
     public void fireHurt() {
-        if (!this.fireImmune) {
-            float protection = 0;
-            ArmorMaterial material;
-            if ((material = getArmorMaterial()) != null) {
-                protection = 1.0f - material.getProtection(DamageType.FIRE);
-            }
+        if(!fireImmune)
+        {
+            float protection = 1.0f - getTotalProtectionAmount(DamageType.FIRE);
             protection = Math.max(protection, 0.01f);
             hurt(null, 1, DamageType.FIRE);
-            this.remainingFireTicks = (int) (40 + 260 * protection);
-            this.maxFireTicks = this.remainingFireTicks;
+            remainingFireTicks = (int) (40 + 260 * protection);
+            maxFireTicks = remainingFireTicks;
         }
     }
 
@@ -669,13 +660,13 @@ public class MobWolf
                     return true;
                 }
             }
-            if (itemstack != null && itemstack.getItem() instanceof IArmorItem<?> armorItem && player.uuid.equals(getWolfOwner())) {
+            if (itemstack != null && itemstack.getItem() instanceof IArmorItem<?> armorItem && armorItem.getArmorShape() == WolfArmorShape.BODY && player.uuid.equals(getWolfOwner())) {
                 if (armorItem.getArmorMaterial() != null && ARMOR_MATERIALS.containsValue(armorItem)) {
-                    if (this.armor != null) {
-                        dropItem(this.armor, 0.0f);
-                        setArmor(null);
+                    if (this.getArmorItem() != null) {
+                        dropItem(this.getArmorItem(), 0.0f);
+                        setArmorItem(null);
                     }
-                    setArmor(new ItemStack(itemstack.getItem(), 1, itemstack.getMetadata(), itemstack.getData()));
+                    setArmorItem(new ItemStack(itemstack.getItem(), 1, itemstack.getMetadata(), itemstack.getData()));
                     if (player.getGamemode().hasBlockConsumption()) {
                         itemstack.stackSize--;
                         if (itemstack.stackSize <= 0) {
@@ -685,9 +676,9 @@ public class MobWolf
                     return true;
                 }
             }
-            if (itemstack == null && player.isSneaking() && this.armor != null && player.uuid.equals(getWolfOwner())) {
-                dropItem(this.armor, 0.0f);
-                setArmor(null);
+            if (itemstack == null && player.isSneaking() && this.getArmorItem() != null && player.uuid.equals(getWolfOwner())) {
+                dropItem(this.getArmorItem(), 0.0f);
+                setArmorItem(null);
                 return true;
             }
             if (player.uuid.equals(getWolfOwner())) {
@@ -808,4 +799,34 @@ public class MobWolf
     public boolean isLeftHanded() {
         return false;
     }
+
+    @Override
+    public @Nullable ItemStack getItemInArmorSlot(@NotNull WolfArmorShape slot) {
+        if (slot == WolfArmorShape.BODY) {
+            return this.getArmorItem();
+        }
+
+        return null;
+    }
+
+    @Override
+    public void setItemInArmorSlot(@NotNull WolfArmorShape slot, @Nullable ItemStack item) {
+        if (slot == WolfArmorShape.BODY) {
+            this.setArmorItem(item);
+        }
+    }
+
+    @Override
+    public int getNumArmorSlots() {
+        return 1;
+    }
+
+    @Override
+    public @Nullable WolfArmorShape getArmorSlotByIndex(int index) {
+        if (index == 0) {
+            return WolfArmorShape.BODY;
+        }
+
+        return null;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBags.java b/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBags.java
index 6296e9515..0f7b8de10 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBags.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/ArmorBags.java
@@ -14,28 +14,28 @@ public abstract class ArmorBags {
     static {
         ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.HEAD,
                 new ArmorBag<>(HumanArmorShape.HEAD)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_HELMET_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_HELMET_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_HELMET_DIAMOND, 5, 0.125f)
                         .addEntry(Items.ARMOR_HELMET_STEEL, 1, 0.125f));
         ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.CHEST,
                 new ArmorBag<>(HumanArmorShape.CHEST)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_CHESTPLATE_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_CHESTPLATE_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_CHESTPLATE_DIAMOND, 5, 0.125f)
                         .addEntry(Items.ARMOR_CHESTPLATE_STEEL, 1, 0.125f));
         ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.LEGS,
                 new ArmorBag<>(HumanArmorShape.LEGS)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_LEGGINGS_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_LEGGINGS_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_LEGGINGS_DIAMOND, 5, 0.125f)
                         .addEntry(Items.ARMOR_LEGGINGS_STEEL, 1, 0.125f));
         ZOMBIE_ARMOR_BAGS.put(HumanArmorShape.BOOTS,
                 new ArmorBag<>(HumanArmorShape.BOOTS)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_BOOTS_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_BOOTS_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_BOOTS_DIAMOND, 5, 0.125f)
@@ -46,28 +46,28 @@ public abstract class ArmorBags {
     static {
         SKELETON_ARMOR_BAGS.put(HumanArmorShape.HEAD,
                 new ArmorBag<>(HumanArmorShape.HEAD)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_HELMET_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_HELMET_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_HELMET_DIAMOND, 5, 0.125f)
                         .addEntry(Items.ARMOR_HELMET_STEEL, 1, 0.125f));
         SKELETON_ARMOR_BAGS.put(HumanArmorShape.CHEST,
                 new ArmorBag<>(HumanArmorShape.CHEST)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_CHESTPLATE_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_CHESTPLATE_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_CHESTPLATE_DIAMOND, 5, 0.125f)
                         .addEntry(Items.ARMOR_CHESTPLATE_STEEL, 1, 0.125f));
         SKELETON_ARMOR_BAGS.put(HumanArmorShape.LEGS,
                 new ArmorBag<>(HumanArmorShape.LEGS)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_LEGGINGS_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_LEGGINGS_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_LEGGINGS_DIAMOND, 5, 0.125f)
                         .addEntry(Items.ARMOR_LEGGINGS_STEEL, 1, 0.125f));
         SKELETON_ARMOR_BAGS.put(HumanArmorShape.BOOTS,
                 new ArmorBag<>(HumanArmorShape.BOOTS)
-                        .addEntry(null, 100, 1.0f)
+                        .addEntry(null, 400, 1.0f)
                         .addEntry(Items.ARMOR_BOOTS_LEATHER, 30, 0.8f)
                         .addEntry(Items.ARMOR_BOOTS_IRON, 10, 0.5f)
                         .addEntry(Items.ARMOR_BOOTS_DIAMOND, 5, 0.125f)
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
index ee2bdf387..cd0b376b2 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
@@ -250,7 +250,7 @@ public class Projectile extends Entity {
     public void waterTick() {
         for (int k = 0; k < 4; k++) {
             double particleDistance = 0.25F;
-            this.world.spawnParticle("bubble", this.x - this.xd * particleDistance, this.y - this.yd * particleDistance, this.z - this.zd * particleDistance, this.xd, this.yd, this.zd, 0);
+            this.world.spawnParticle("bubble", this.x - this.xd * particleDistance, this.y - this.yd * particleDistance, this.z - this.zd * particleDistance, this.xd, this.yd, this.zd, this.world.dimension.id);
         }
 
         this.projectileSpeed = 0.8F;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
index 214b20130..c4550ac05 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileCannonballBouncy.java
@@ -111,7 +111,7 @@ public class ProjectileCannonballBouncy extends ProjectileCannonball {
         if (isInWater()) {
             for (int i = 0; i < 4; i++) {
                 double particleDistance = 0.25D;
-                this.world.spawnParticle("bubble", this.x - this.xd * particleDistance, this.y - this.yd * particleDistance, this.z - this.zd * particleDistance, this.xd, this.yd, this.zd, 0);
+                this.world.spawnParticle("bubble", this.x - this.xd * particleDistance, this.y - this.yd * particleDistance, this.z - this.zd * particleDistance, this.xd, this.yd, this.zd, this.world.dimension.id);
             }
 
             deceleration = 0.8F;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 4decb46f8..7dd61afcc 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -286,11 +286,11 @@ public class EntityBoat extends Entity {
                 if (this.random.nextBoolean()) {
                     double posX = (this.x - d12 * d18 * 0.8D) + d15 * d20;
                     double posZ = this.z - d15 * d18 * 0.8D - d12 * d20;
-                    this.world.spawnParticle("splash", posX, this.y - 0.125D, posZ, this.xd, this.yd, this.zd, 0);
+                    this.world.spawnParticle("splash", posX, this.y - 0.125D, posZ, this.xd, this.yd, this.zd, this.world.dimension.id);
                 } else {
                     double posX = this.x + d12 + d15 * d18 * 0.7D;
                     double posZ = (this.z + d15) - d12 * d18 * 0.7D;
-                    this.world.spawnParticle("splash", posX, this.y - 0.125D, posZ, this.xd, this.yd, this.zd, 0);
+                    this.world.spawnParticle("splash", posX, this.y - 0.125D, posZ, this.xd, this.yd, this.zd, this.world.dimension.id);
                 }
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 1f6db4191..f90a48dfa 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -335,21 +335,18 @@ public class EntityMinecart extends Entity implements Container {
         this.yo = this.y;
         this.zo = this.z;
         this.yd -= 0.04D;
-        int blockX = MathHelper.floor(this.x);
-        int blockY = MathHelper.floor(this.y);
-        int blockZ = MathHelper.floor(this.z);
         TilePos tilePos = new TilePos(this.x, this.y, this.z);
         TilePos queryPos = new TilePos();
         if (BlockLogicRail.isRailBlockAt(this.world, tilePos.down(queryPos))) {
-            blockY--;
+            tilePos.y--;
         }
         final double maxSpeed = 0.4D;
         boolean didFurnacePush = false;
         final double d5 = 0.0078125D;
         Block<?> block = this.world.getBlockType(tilePos);
-        if (block != null && block.getLogic() instanceof BlockLogicRail rail) {
+        if (block.getLogic() instanceof BlockLogicRail rail) {
             Vector3dc vec3d = getPos(this.x, this.y, this.z);
-            this.y = blockY;
+            this.y = tilePos.y;
             boolean onPoweredPoweredRail = false;
             boolean onUnpoweredPoweredRail = false;
             if (block == Blocks.RAIL_POWERED) {
@@ -359,7 +356,7 @@ public class EntityMinecart extends Entity implements Container {
             RailDirection railDirection = rail.getRailDirection(this.world, new TilePos(tilePos));
 
             if (railDirection.isSloped()) {
-                this.y = blockY + 1;
+                this.y = tilePos.y + 1;
             }
             if (railDirection == RailDirection.SLOPE_E) {
                 this.xd -= d5;
@@ -398,17 +395,17 @@ public class EntityMinecart extends Entity implements Container {
                     this.zd *= 0.5D;
                 }
             }
-            double d18 = (double) blockX + 0.5D + (double) nextRailTable[0][0] * 0.5D;
-            double d19 = (double) blockZ + 0.5D + (double) nextRailTable[0][2] * 0.5D;
-            double d20 = (double) blockX + 0.5D + (double) nextRailTable[1][0] * 0.5D;
-            double d21 = (double) blockZ + 0.5D + (double) nextRailTable[1][2] * 0.5D;
+            double d18 = tilePos.x + 0.5D + (double) nextRailTable[0][0] * 0.5D;
+            double d19 = tilePos.z + 0.5D + (double) nextRailTable[0][2] * 0.5D;
+            double d20 = tilePos.x + 0.5D + (double) nextRailTable[1][0] * 0.5D;
+            double d21 = tilePos.z + 0.5D + (double) nextRailTable[1][2] * 0.5D;
             d9 = d20 - d18;
             d10 = d21 - d19;
             double d17;
             if (d9 == 0.0D) {
-                d17 = this.z - (double) blockZ;
+                d17 = this.z - (double) tilePos.z;
             } else if (d10 == 0.0D) {
-                d17 = this.x - (double) blockX;
+                d17 = this.x - (double) tilePos.x;
             } else {
                 double d22 = this.x - d18;
                 double d24 = this.z - d19;
@@ -434,9 +431,9 @@ public class EntityMinecart extends Entity implements Container {
             _zd = MathHelper.clamp(_zd, -maxSpeed, maxSpeed);
 
             move(_xd, 0.0D, _zd);
-            if (nextRailTable[0][1] != 0 && MathHelper.floor(this.x) - blockX == nextRailTable[0][0] && MathHelper.floor(this.z) - blockZ == nextRailTable[0][2]) {
+            if (nextRailTable[0][1] != 0 && MathHelper.floor(this.x) - tilePos.x == nextRailTable[0][0] && MathHelper.floor(this.z) - tilePos.z == nextRailTable[0][2]) {
                 setPos(this.x, this.y + (double) nextRailTable[0][1], this.z);
-            } else if (nextRailTable[1][1] != 0 && MathHelper.floor(this.x) - blockX == nextRailTable[1][0] && MathHelper.floor(this.z) - blockZ == nextRailTable[1][2]) {
+            } else if (nextRailTable[1][1] != 0 && MathHelper.floor(this.x) - tilePos.x == nextRailTable[1][0] && MathHelper.floor(this.z) - tilePos.z == nextRailTable[1][2]) {
                 setPos(this.x, this.y + (double) nextRailTable[1][1], this.z);
             }
             if (this.passenger != null) {
@@ -478,10 +475,10 @@ public class EntityMinecart extends Entity implements Container {
             }
             int newBlockX = MathHelper.floor(this.x);
             int newBlockZ = MathHelper.floor(this.z);
-            if (newBlockX != blockX || newBlockZ != blockZ) {
+            if (newBlockX != tilePos.x || newBlockZ != tilePos.z) {
                 vel = Math.hypot(this.xd, this.zd);
-                this.xd = vel * (double) (newBlockX - blockX);
-                this.zd = vel * (double) (newBlockZ - blockZ);
+                this.xd = vel * (double) (newBlockX - tilePos.x);
+                this.zd = vel * (double) (newBlockZ - tilePos.z);
             }
             if (getType() == FURNACE_CART) {
                 double pushMagnitude = Math.hypot(this.xPush, this.zPush);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
index 7b08f9f97..387d2b673 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemEgg.java
@@ -38,8 +38,10 @@ public class ItemEgg extends Item implements IDispensable {
 
     @Override
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
-        ProjectileEgg projectileEgg = new ProjectileEgg(world, x, y, z);
-        projectileEgg.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
-        world.entityJoinedWorld(projectileEgg);
+        if (selfStack.consumeItem(null)) {
+            ProjectileEgg projectileEgg = new ProjectileEgg(world, x, y, z);
+            projectileEgg.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            world.entityJoinedWorld(projectileEgg);
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index 573cdc66f..663c88b78 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -115,8 +115,10 @@ public class ItemPebble extends Item implements IDispensable {
 
     @Override
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
-        ProjectilePebble projectilePebble = new ProjectilePebble(world, x, y, z);
-        projectilePebble.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
-        world.entityJoinedWorld(projectilePebble);
+        if (selfStack.consumeItem(null)) {
+            ProjectilePebble projectilePebble = new ProjectilePebble(world, x, y, z);
+            projectilePebble.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            world.entityJoinedWorld(projectilePebble);
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
index fa54d5791..be24c7702 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
@@ -1,14 +1,19 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.ProjectileArrow;
+import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemQuiver extends Item implements IArmorItem<HumanArmorShape> {
+import java.util.Random;
+
+public class ItemQuiver extends Item implements IArmorItem<HumanArmorShape>, IDispensable {
 
     public ItemQuiver(@NotNull String name, @NotNull String namespaceId, int id) {
         super(name, namespaceId, id);
@@ -113,4 +118,16 @@ public class ItemQuiver extends Item implements IArmorItem<HumanArmorShape> {
 	public @NotNull HumanArmorShape getArmorShape() {
 		return HumanArmorShape.CHEST;
 	}
+
+    @Override
+    public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
+        int count = getArrowCount(selfStack);
+        if (count > 0) {
+            final @NotNull ProjectileArrow arrow = new ProjectileArrow(world, x, y, z, 0);
+            arrow.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            arrow.setDoesArrowBelongToPlayer(true);
+            world.entityJoinedWorld(arrow);
+            setArrowCount(selfStack, count - 1);
+        }
+    }
 }
